"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupBy = void 0;
var enumerable_1 = require("../enumerable");
var equality_comparer_1 = require("../equality-comparer");
var grouping_1 = require("../grouping");
var utils = __importStar(require("../utils"));
var assistance = __importStar(require("./assistance"));
function groupBy(source, keySelector, elementSelector, comparer) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('keySelector', keySelector);
    var _elementSelector = elementSelector || (function (x) { return x; });
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    return enumerable_1.Enumerable.AsEnumerable(assistance
        .group(source, keySelector, _elementSelector, function (x, y) { return comparer.Equals(x, y); })
        .map(function (g) { return new grouping_1.Grouping(g.Key, enumerable_1.Enumerable.AsEnumerable(g.List)); }));
}
exports.groupBy = groupBy;
//# sourceMappingURL=group-by.js.map