"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceEqual = void 0;
var equality_comparer_1 = require("../equality-comparer");
var utils = __importStar(require("../utils"));
function sequenceEqual(first, second, comparer) {
    utils.throws.ThrowIfNull('first', first);
    utils.throws.ThrowIfNull('second', second);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    var left = first[Symbol.iterator]();
    var right = second[Symbol.iterator]();
    while (true) {
        var x = left.next();
        var y = right.next();
        if (x.done) {
            return y.done;
        }
        else if (y.done) {
            return false;
        }
        if (!comparer.Equals(x.value, y.value)) {
            return false;
        }
    }
}
exports.sequenceEqual = sequenceEqual;
//# sourceMappingURL=sequence-equal.js.map